# Summary

* [An Introduction to Modern CMake](README.md)
    * [Installing CMake](chapters/intro/installing.md)
    * [Running CMake](chapters/intro/running.md)
    * [Dos and Don'ts](chapters/intro/dodonot.md)
    * [What's new in CMake](chapters/intro/newcmake.md)
* [Introduction to the Basics](chapters/basics.md)
    * [Variables and the Cache](chapters/basics/variables.md)
    * [Programming in CMake](chapters/basics/functions.md)
    * [Communicating with your code](chapters/basics/comms.md)
    * [How to Structure Your Project](chapters/basics/structure.md)
    * [Running Other Programs](chapters/basics/programs.md)
    * [A Simple Example](chapters/basics/example.md)
* [Adding Features](chapters/features.md)
    * [C++11 and Beyond](chapters/features/cpp11.md)
    * [Small but common needs](chapters/features/small.md)
    * [Utilities](chapters/features/utilities.md)
    * [Useful modules](chapters/features/modules.md)
    * [IDEs](chapters/features/ides.md)
    * [Debugging](chapters/features/debug.md)
* [Including Projects](chapters/projects.md)
    * [Submodule](chapters/projects/submodule.md) 
    * [DownloadProject](chapters/projects/download.md) 
    * [Fetch (CMake 3.11)](chapters/projects/fetch.md) 
* [Testing](chapters/testing.md)
    * [GoogleTest](chapters/testing/googletest.md)
    * [Catch](chapters/testing/catch.md)
* [Exporting and Installing](chapters/install.md)
    * [Installing](chapters/install/installing.md)
    * [Exporting](chapters/install/exporting.md)
    * [Packaging](chapters/install/packaging.md)
* [Looking for Libraries (Packages)](chapters/packages.md)
    * [CUDA](chapters/packages/CUDA.md)
    * [OpenMP](chapters/packages/OpenMP.md)
    * [Boost](chapters/packages/Boost.md)
    * [MPI](chapters/packages/MPI.md)
    * [ROOT](chapters/packages/ROOT.md)
        * [UseFile Example](examples/root-usefile/README.md)
        * [Simple Example](examples/root-simple/README.md)
        * [Dictionary Example](examples/root-dict/README.md)
    * [Minuit2](chapters/packages/Minuit2.md)


<!--
* [Download PDF](ref://modern-cmake.pdf)
* [Browse the source](https://gitlab.com/CLIUtils/modern-cmake) -->
